#!/usr/bin/perl
 ##################################################################
# Autoresponder and Mailing List Manager                           #
# Version 4.1 Lite                                                 #
# Copyright 2005-2020                                              #
# A free script from:   http://free-software.biz/amlmlite.html     #
 ##################################################################
#                          COPYRIGHT NOTICE                        #
#                                                                  #
#  Copyright 2005-2020 http://free-software.biz/amlmpro.html       #
#                                                                  #
#          Please read license.htm or license.txt file             #
#             before proceeding with installation.                 #
#                                                                  #
# You are granted permission to use this Software as long as:      #
#                                                                  #
#  - You do not modify the Software in any way                     #
#  - You do not modify this agreement in any way                   #
#  - You do not claim ownership of any ammended files              #
#  - You do not remove any copyright notices                       #
#  - You do not change/remove the 'Autoresponder and Mailing Listr #
#    Manager 4.1 Lite' name in any of the source files,            #
#    generated URLs and outgoing emails                            #
#                                                                  #
# Modifying, selling the code for this software over the Internet  #
# or in any other medium is forbidden.                             #
#                                                                  #
# If you really need to remove the return links, go to             #
# http://free-software.biz/amlmpro.html                            #
# and upgrade to the Pro version                                   #
#                                                                  #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,  #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES  #
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND         #
# NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT     #
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,     #
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     #
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR    #
# OTHER DEALINGS IN THE SOFTWARE.                                  #
#                                                                  #
 ##################################################################

require 'conf.cgi';
%CONF=(); %PAR=();%ACCOUNT=();
$q=new CGI;
&par_prepare;
&db_prepare;

if ($PAR{act} eq "un"){
	unsubscribe();
	exit;
}
if ($PAR{act}){
	confirm();
	exit;
}
unless(exists $ACCOUNT{$PAR{account}}){
	printheader();
	print $q->h1("OOPS INCORRECT FORM OPTIONS");
	exit(1);
}
	local @FIELDS;
	@FIELDS=load_account_fields($PAR{account});
	my $page = new hfparser(
		DATA=>"$SHABL_DIR/regerror.html",
		ERROR_AFTER_INPUT=>1
	);	
	if ($PAR{account}){
		$page->set_error("email","Email is incorrect") unless checkemail($PAR{email});
		$page->set_error("name","required") unless ($PAR{name}=~/\w/);
		foreach(@FIELDS){
				next unless $_->{is_req};
				my $param="dp".$_->{key};
				$page->set_error($param,"required") unless ($PAR{$param}=~/\w/);
			}
		unless($page->is_error){
			&registerUSER();
			print $q->redirect($CONF{redirsub});
			exit(1);
		}
	}
	&printheader;
	my $add;
	foreach (@FIELDS){
		$add.=<<ALL__;
		<TR class="data">
		<td align="right"><b>$_->{name}:</b></td>
		<TD>{fm_$_->{type}_dp$_->{key}}</TD></TR>
ALL__
	}
	$page->ChangeData('{additional_fields}',$add);
	foreach(0..30){
		$page->add_element("days",$_)
	}
	$page->set_default_input("text","size",35);
	$page->set_default_input("textarea","rows",4);
	$page->set_default_input("textarea","columns",35);
	$page->ParseData;
	print $page->as_string;
#################
sub registerUSER{
	my %accounts;
	my @addaccount=$q->param("addaccount");
	push @addaccount,$PAR{account};
	my %doi;
	my $SQL="SELECT * FROM ${PREF}account LEFT JOIN ${PREF}conf ON fk_account=pk_account WHERE pk_account IN (".join(",",map{$db->quote($_)}@addaccount).") AND pk_conf='isdoi' AND conf_value='on'";
	my $out=$db->prepare($SQL);
	$out->execute();
	&Error($SQL);
	my %output;
	while (%output=%{$out->fetchrow_hashref}){
		$doi{$output{fk_account}}=1;
	}
	my $keynow,$isact,$doikey;
	my $randoi;
	my @chars=('a'..'z','A'..'Z',0..9,'_');
	$randoi=join("", @chars[map{rand @chars}(1..10)]);
	my $count=GetSQLCount("SELECT * FROM ${PREF}user WHERE email=? AND fk_account=?",$PAR{email},$PAR{account});
	my $redirtoaccount;
	$PAR{email}=prepareemail($PAR{email});
	$PAR{name}=preparename($PAR{name});
	unless($count){
		$isact=0 if $doi{$PAR{account}};
		$isact=1 unless $doi{$PAR{account}};
		my $isactmess="";
		$isactmess.="with double opt in" if	$doi{$PAR{account}};
		$keynow=insert_db("${PREF}user",{email=>$PAR{email},name=>$PAR{name},isact=>$isact,days=>0,fk_account=>$PAR{account}});
		doLog("User $PAR{name} ($PAR{email}) was registered to account $ACCOUNT{$PAR{account}} $isactmess");
		$db->do("UPDATE ${PREF}user SET datereg=$NOW WHERE pk_user=?",undef,$keynow);
		foreach(@FIELDS){
			my $param="dp".$_->{key};
			save_user_parametr($_->{key},$keynow,$PAR{$param});
		}
	
		if($doi{$PAR{account}}){
			$doikey=insert_db("${PREF}doi",{ran=>$randoi});
			insert_db("${PREF}doiaccounts",{fk_doi=>$doikey,fk_account=>$PAR{account},fk_user=>$keynow});
			$redirtoaccount=$PAR{account};
		}else{
			if($CONF{sendsubscr}){
				my $messages=select_one_db("SELECT * FROM ${PREF}mess WHERE fk_account=? AND typesend=?",$PAR{account},'subscribe');
				print $messages->{pk_mess};
				if ($messages->{pk_mess}){
					AddToSend($keynow,$messages->{pk_mess});
				}
			}
		}
		if($CONF{isnotifsubscr}){
			$msg = new MIME::Lite 
				From    =>"$PAR{name} <$PAR{email}>",
				To      =>"$CONF{adminname} <$CONF{adminemail}>",
				Subject =>"User registration",
				Data    =>"User $PAR{name} <$PAR{email}> registered to account: $ACCOUNT{$PAR{account}}";
			MIMEsendto($CONF{adminemail},$msg);
			
		}
	}
	foreach(@addaccount){
		next unless $_;
		my $count=GetSQLCount("SELECT * FROM ${PREF}user WHERE email=? AND fk_account=?",$PAR{email},$_);
		&Error;
		next if $count;
		$isact=0 if $doi{$_};
		$isact=1 unless $doi{$_};
		my $isactmess="";
		#$isactmess.="on" if $doi{$_};
		#$isactmess.="off" unless $doi{$_};
		$keynow=insert_db("${PREF}user",{email=>$PAR{email},name=>$PAR{name},isact=>$isact,days=>0,fk_account=>$_});
		doLog("User $PAR{name} ($PAR{email}) was registered to account $ACCOUNT{$_} $isactmess");
		$db->do("UPDATE ${PREF}user SET datereg=$NOW WHERE pk_user=?",undef,$keynow);
		if($doi{$_}){
			unless ($doikey){
				$doikey=insert_db("${PREF}doi",{ran=>$randoi});
			}
			insert_db("${PREF}doiaccounts",{fk_doi=>$doikey,fk_account=>$_,fk_user=>$keynow});
		}
	}
	if ($doikey){
	my $address=$ENV{HTTP_HOST};
	my $scriptdir=$ENV{SCRIPT_NAME};
	(my $src=$scriptdir)=~s#[^/]*$##;
		my $DATA=<<ALL__;
To confirm your subscription, click on the link below 
(you must be connected to the internet at the time):

http://$address${src}register.cgi?id=$randoi&act=$redirtoaccount

If you did not make the request, there is no need
to take any further action.
ALL__
   	$msg = new MIME::Lite 
                From    =>"$CONF{fromname} <$CONF{fromemail}>",
                To      =>"$PAR{name} <$PAR{email}>",
                Subject =>"Please confirm your subscription",
                Data    =>$DATA;
	MIMEsendto($PAR{email},$msg);
	}
}
sub confirm{
	my @USERS;
	my $myconf=select_one_db("SELECT * FROM ${PREF}conf WHERE fk_account=? AND pk_conf=?",$PAR{act},'doiconfurl');
	my $redirpage=$myconf->{conf_value};
	my $SQL="SELECT * FROM ${PREF}doi LEFT JOIN ${PREF}doiaccounts ON pk_doi=fk_doi WHERE ran=?";
	my $out=$db->prepare($SQL);
	$out->execute($PAR{id});
	&Error($SQL);
	my %output;
	my @TODO;
	my $doikey;
	while (%output=%{$out->fetchrow_hashref}){
		push(@USERS,$output{fk_user});
		$doikey=$output{pk_doi};	
	}
	if (@USERS){
		$db->do("UPDATE ${PREF}user SET  isact= 1, datereg=$NOW WHERE pk_user IN (".join(",",@USERS).")");
	}
	foreach(@USERS){
		my $user=select_one_db("SELECT * FROM ${PREF}user WHERE pk_user=?",$_);
		if ($user->{email}){
			my $subscrmess=select_one_db("SELECT pk_mess FROM ${PREF}mess WHERE fk_account=? AND typesend='subscribe'",$PAR{act});
			if ($subscrmess->{pk_mess}){
				AddToSend($user->{pk_user},$subscrmess->{pk_mess});		
			}
			doLog("User $user->{name} ($user->{email}) was confirmed in account $ACCOUNT{$user->{fk_account}} by double opt in");
			
		}

	}
	$db->do("DELETE FROM ${PREF}doiaccounts WHERE fk_doi=?",undef,$doikey);
	$db->do("DELETE FROM ${PREF}doi WHERE pk_doi=?",undef,$doikey);
	print $q->redirect($redirpage);
	exit();	
}
sub unsubscribe{
	my $myconf=select_one_db("SELECT * FROM ${PREF}conf WHERE fk_account=? AND pk_conf=?",$PAR{at},'redirrem');
	my $user=select_one_db("SELECT * FROM ${PREF}user WHERE fk_account=? AND email=?",$PAR{at},$PAR{em});
	if ($user->{pk_user}){
		%CONF=loadCONF($PAR{at});
		if($CONF{sendunsubscr}){
			my $messages=select_one_db("SELECT * FROM ${PREF}mess WHERE fk_account=? AND typesend='unsubscribe'",$PAR{at});
			print $messages->{pk_mess};
			if ($messages->{pk_mess}){
				doLog("Creating unsubscribe message for user $user->{name} $user->{email}");
				AddToSend($user->{pk_user},$messages->{pk_mess});
			}else{
				doLog("Deleting  user $user->{name} $user->{email} : unsubscribe message was not found");
				DeleteUser($user->{pk_user});	
			}
		}else{
			DeleteUser($user->{pk_user});	
			doLog("Deleting  user $user->{name} $user->{email}");			
		}
		my $userid=$user->{pk_user};
		if($CONF{isnotifunsubscr}){
				$msg = new MIME::Lite 
					From    =>"$user->{email}",
					To      =>"$CONF{adminname} <$CONF{adminemail}>",
					Subject =>"User unsubscribed",
					Data    =>"User $user->{name} <$user->{email}> removed from account: $ACCOUNT{$PAR{at}}";
				MIMEsendto($CONF{adminemail},$msg);
		}
	}else{
		printheader();
		my $redirpage=$myconf->{conf_value};
		print $q->start_html("Autoresponder and Mailing List Manager AMLM Lite");
		print $q->h1("<center><span style=\"font-family: Tahoma, Verdana; font-size: 8pt\"><a href=\"http://free-software.biz/amlmpro.html/\" target=\"_blank\">Powered by Autoresponder + Mailing List Manager</a></span><br><br><br><br><br><span style=\"font-family: Tahoma, Verdana; font-size: 20pt; font-weight: bold\">The email address is already unsubscribed</span></center>");
		print $q->end_html();
		exit();
	}
	my $redirpage=$myconf->{conf_value};
	print $q->redirect($redirpage);
	exit();	
}

