#!/usr/bin/perl
 ##################################################################
# Autoresponder and Mailing List Manager                           #
# Version 4.1 Lite                                                 #
# Copyright 2005-2020                                              #
# A free script from:   http://free-software.biz/amlmlite.html     #
 ##################################################################
#                          COPYRIGHT NOTICE                        #
#                                                                  #
# Copyright 2005-2020 http://free-software.biz/amlmpro.html        #
#                                                                  #
#          Please read license.htm or license.txt file             #
#             before proceeding with installation.                 #
#                                                                  #
# You are granted permission to use this Software as long as:      #
#                                                                  #
#  - You do not modify the Software in any way                     #
#  - You do not modify this agreement in any way                   #
#  - You do not claim ownership of any ammended files              #
#  - You do not remove any copyright notices                       #
#  - You do not change/remove the 'Autoresponder and Mailing List  #
#    Manager 4.1 Lite' name in any of the source files,            #
#    generated URLs and outgoing emails                            #
#                                                                  #
# Modifying, selling the code for this software over the Internet  #
# or in any other medium is forbidden.                             #
#                                                                  #
# If you really need to remove the return links, go to             #
# http://free-software.biz/amlmpro.html                            #
# and upgrade to the Pro version                                   #
#                                                                  #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,  #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES  #
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND         #
# NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT     #
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,     #
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     #
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR    #
# OTHER DEALINGS IN THE SOFTWARE.                                  #
#                                                                  #
 ##################################################################
local %ACT=        (
        ""        =>\&print_frameset,
        account   =>\&print_account,
        mainbody  =>\&print_main,
	settings  =>\&print_settings,
	getfile  =>\&print_getfile,
	delfile  =>\&print_delfile,
	subscrmess=>\&print_subsmess,
	unsubscrmess=>\&print_unsubsmess,
	showmess=>\&print_show_mess,
	showrfcmess=>\&print_show_rfc_mess
);
local @ACCOUNTMENU=(
        {name=>"Account Menu",    params=>{act2=>""}},
        {name=>"Account Options",params=>{act2=>"config"}},
        {name=>"HTML Form",    params=>{act2=>"columns"}},
        {name=>"Subscriber Manager", params=>{act2=>"users"}},
        {name=>"Edit Messages", params=>{act2=>"mess"}}

);
local @SETTINGSMENU=(
        {name=>"Main",    params=>{act2=>""}},
        {name=>"Personal",params=>{act2=>"personal"}},
        {name=>"SMTP/sendmail",    params=>{act2=>"smtp"}},
        {name=>"Access",    params=>{act2=>"pass"}},
	{name=>"Time Sync.",    params=>{act2=>"timecorr"}},
	{name=>"Logs",    params=>{act2=>"log"}},
	{name=>"Performance",    params=>{act2=>"test"}}

);

require 'conf.cgi';
###
%CONF=(); %PAR=();%ACCOUNT=();
###
&par_prepare;
&db_prepare;
my $address=$ENV{HTTP_HOST};
my $scriptdir=$ENV{SCRIPT_NAME};
(my $src=$scriptdir)=~s#[^/]*$##;
save_config(0,"serverurl","http://$address${src}");
&sessiya;
&process_all;
##################
sub process_all{
	if ($ACT{$PAR{act}}){
		my $sub_ref=$ACT{$PAR{act}};
		&$sub_ref if $sub_ref;
	}else{
		printheader();
		print $q->start_html("Error");
		print $q->h1("please do not change the url");
		print $q->end_html;
		exit;
	}
}
###################
sub get_account_menu{
	my $ref_menu=shift;
	my @MENU=@{$ref_menu};
	my $out;
	$out=$q->start_table({-border=>0,-align=>"center",width=>"100%"})."<TR>";
	my $count=@MENU;
	my $width=100/$count."%" if $count;
	my $menu;
	my $acct="";
	$acct='&account='.$PAR{account} if $PAR{account};
	my @menu=map{$q->td({-align=>center, -width=>$width},
				$q->a({-href=>"$SCRIPT_NAME?act=$PAR{act}&act2=".$_->{params}{act2}."&ses=$PAR{ses}".$acct,
						-target=>'_self', -class=>($PAR{act2} eq $_->{params}{act2}) ? 'menuACT' : 'menu'},"<NOBR>$_->{name}</NOBR>")
			)
		}@MENU;
	$out.=join "\n", @menu;
	$out.="</TR>".$q->end_table() ;	
	return $out;
}
##################
sub get_full_url{
	my $pars=shift;
	my %pars=%$pars;
	my $qq = new CGI;
	foreach (keys %pars){
		$qq->param($_,$pars{$_})
	}
	#-path_info=>1
	#-query=>1
	return $qq->url(-absolute=>1,-query=>1);
}

####################
#begin mapping functions
####################
#SETTINGS
sub print_settings_main{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);
	$page->SplitData("#begin#main","#end#main");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
###################
sub print_settings_personal{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);
	if ($PAR{issubmit}){
		$page->set_error("adminname","Your name is required") unless $PAR{adminname};
		if ($PAR{adminemail}){
			$page->set_error("adminemail","Email is incorrect") unless checkemail($PAR{adminemail});
		}else{
			$page->set_error("adminemail","Email is required");
		}
	}
	if ($PAR{issubmit} && !$page->is_error){
		save_config(0,"adminname",$PAR{adminname});
		save_config(0,"adminemail",$PAR{adminemail});
		save_config(0,"statbyemail",$PAR{statbyemail});		
		$page->add_regesp('{error}',"<h1 class=\"mess\">Settings updated</h1>");
	}
	$page->set_def("statbyemail",$CONF{statbyemail});
	$page->set_def("adminname",$CONF{adminname});
	$page->set_def("adminemail",$CONF{adminemail});	
	$page->SplitData("#begin#personal","#end#personal");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
###########################
sub print_settings_smtp{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);

	if ($PAR{issubmit}){
		if ($PAR{modsend} eq ""){
			$page->set_error("modsend","You must select this")
		}else{
			if ($PAR{modsend} eq 'sendmail'){
				unless ($PAR{sendmail}){
					$page->set_error("sendmail","Sendmail is required now") 
				}else{
					if($PAR{sendmail}=~/[ ><;&]/){
						$page->set_error("sendmail","Incorrect path to sendmail") 
					}elsif(! -f $PAR{sendmail}){
						$page->set_error("sendmail","Sendmail is not exist on this server")
					}
				}
			}elsif($PAR{modsend} eq 'SMTP'){
				$page->set_error("smtp","SMTP server name is required now") unless $PAR{smtp};
			}
		}
	}
	if ($PAR{issubmit} && !$page->is_error){
		save_config(0,"sendmail",$PAR{sendmail});
		save_config(0,"modsend",$PAR{modsend});
		save_config(0,"smtp",$PAR{smtp});
		$page->add_regesp('{error}',"<h1 class=\"mess\">Settings updated</h1>");
	}
	$page->add_element("modsend","","--select--");
	$page->add_element("modsend","sendmail");
	$page->add_element("modsend","SMTP");
	$page->set_def("modsend",$CONF{modsend});
	$page->set_def("sendmail",$CONF{sendmail});	
	$page->set_def("smtp",$CONF{smtp});		
	
	$page->SplitData("#begin#smtp","#end#smtp");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
#################
sub print_settings_timecorr{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);
	if ($PAR{issubmit}){
		if ($PAR{timecorr} ne ""){
			unless ($PAR{timecorr}=~m#^(\+|-)\d\d:\d\d$#){
				$page->set_error("timecorr","Incorrect format");
			}
		}
	}
	if ($PAR{issubmit} && !$page->is_error){
		save_config(0,"timecorr",$PAR{timecorr});
		$page->add_regesp('{error}',"<h1 class=\"mess\">Settings updated</h1>");
		$CONF{timecorr}=$PAR{timecorr};
		$MY_TIME=time+TimeToSec($CONF{timecorr});
		$NOW=GetNow($PAR{timecorr});
		$db->do("UPDATE ${PREF}ses SET date=$NOW WHERE ran=?", undef, $PAR{ses});
	}
	$page->add_regesp('{time}',scalar(localtime()));
	$page->add_regesp('{mytime}',scalar(localtime($MY_TIME)));
	
	$page->set_def("timecorr",$CONF{timecorr});
	$page->SplitData("#begin#time","#end#time");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
########################
sub print_settings_pass{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);
	if ($PAR{issubmit}){
		$page->set_error("oldpass","Incorrect") if ($PAR{oldpass} ne $CONF{adminpwd});
		if ($PAR{newpass1} && $PAR{newpass2}){
			$page->set_error("newpass1","Not equal") if ($PAR{newpass1} ne $PAR{newpass2});
			$page->set_error("newpass2","Not equal") if ($PAR{newpass1} ne $PAR{newpass2});
		}else{
			$page->set_error("newpass1","Required") unless $PAR{newpass1};
			$page->set_error("newpass2","Required") unless $PAR{newpass2};			
		}
	}
	if ($PAR{issubmit} && !$page->is_error){
		save_config(0,"adminpwd",$PAR{newpass1});
		$page->add_regesp('{error}',"<h1 class=\"mess\">Settings updated</h1>"."<A href=\"$SCRIPT_NAME\" target=\"parent\">LogOut to check</a>");
	}

	$page->SplitData("#begin#pass","#end#pass");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
################
sub print_settings_test{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);
	$page->add_regesp("{conf_mail}",$CONF{modsend});			
	if ($PAR{issubmit}){
		unless($PAR{emailtest}){
			$page->set_error("emailtest","is required");
		}else{
			unless(checkemail($PAR{emailtest})){
				$page->set_error("emailtest","email  incorrect");				
			}
		}
		unless($PAR{messcount}){
			$page->set_error("messcount","is required");
		}else{
			if ($PAR{messcount}=~/[^0-9]/){
				$page->set_error("messcount","digits only");
			}elsif($PAR{messcount}>300){
				$page->set_error("messcount","300 is maximum");
			}elsif($PAR{messcount}<30){
				$page->set_error("messcount","30 is minimum");
			}
		}
	}
	if ($PAR{issubmit} && !$page->is_error()){
		my $starttime=time();
		my $DATA=<<ALL__;

This is a performance test message.

  $ENV{SERVER_ADMIN}
  $ENV{HTTP_HOST}
  $ENV{REMOTE_ADDR}
ALL__
		
		$msg = new MIME::Lite 
			From    =>"$CONF{adminname} <$CONF{adminemail}>",
			To      =>" <$PAR{emailtest}>",
			Subject =>"Performance test message",
			Data    =>$DATA;

		foreach(1..$PAR{messcount}){
			MIMEsendto($PAR{emailtest},$msg);
		}
		my $endtime=time();
		my $sec=$endtime-$starttime;
		$sec=1 unless $sec;
		$page->SplitData("#begin#testresult","#end#testresult");
		$page->deleteBEFORE_AFTER();
		$page->add_regesp("{messcount}",$PAR{messcount});
		$page->add_regesp("{emailtest}",$PAR{emailtest});		
		$page->add_regesp("{seconds}",$sec);
		$page->add_regesp("{mess_sec}",sprintf("%4d",$PAR{messcount}/$sec));
		$page->add_regesp("{mess_min}",sprintf("%4d",$PAR{messcount}/$sec*60));		
		$page->add_regesp("{mess_hour}",sprintf("%4d",$PAR{messcount}/$sec*60*60));				
		$page->ParseData;		
		return $page->as_string;		
		
	}else{
		$page->SplitData("#begin#test","#end#test");
		$page->deleteBEFORE_AFTER();
		$page->set_def("emailtest",$CONF{adminemail});		
		$page->set_input("messcount",{size=>3,maxlength=>3});
		$page->set_def("messcount",50);
		$page->ParseData;
		return $page->as_string;
	}
}
################
sub print_settings_log{
	my $page = new hfparser(
		DATA=>$settings_shabl		
	);
	$page->SplitData("#begin#log","#end#log");
	$page->deleteBEFORE_AFTER();
	if ($PAR{issubmit}){
		save_config(0,"enablelog",$PAR{enablelog});
		if($PAR{cleanall}){
			$db->do("DELETE FROM ${PREF}log");
			&Error;
		}
		if($PAR{cleandate}){
			my $WHERE="WHERE date BETWEEN ".$db->quote("$PAR{year1}-$PAR{month1}-$PAR{day1}")." AND DATE_ADD(".$db->quote("$PAR{year2}-$PAR{month2}-$PAR{day2}").", INTERVAL 1 DAY)";
			$db->do("DELETE FROM ${PREF}log $WHERE");
			&Error;
		}
	}
	#DATE
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($MY_TIME);
	$year+=1900;$mon++;
	foreach (1..31){
		my $dd=sprintf("%02d",$_);
		$page->add_element("day1",$_,$dd);
		$page->add_element("day2",$_,$dd)
	}
	$page->set_def("day1",$mday);	$page->set_def("day2",$mday);
	my @month=qw(January February March April May June July August September October November December);
	foreach (1..12){
		$page->add_element("month1",$_,$month[$_-1]);$page->add_element("month2",$_,$month[$_-1]);
	}
	$page->set_def("month1",$mon);	$page->set_def("month2",$mon);
	foreach (2002..$year){
		$page->add_element("year1",$_);
		$page->add_element("year2",$_);
	}
	$page->set_def("year1",$year);	$page->set_def("year2",$year);
	#END DATE
	$page->set_def("enablelog",$CONF{enablelog});
	my @WHERE=();
	if ($PAR{issubmit}){
		if ($PAR{usedate}){
			push(@WHERE,"date BETWEEN ".$db->quote("$PAR{year1}-$PAR{month1}-$PAR{day1}")." AND DATE_ADD(".$db->quote("$PAR{year2}-$PAR{month2}-$PAR{day2}").", INTERVAL 1 DAY)");
		}
	}else{
		push(@WHERE,"date BETWEEN '$year-$mon-$mday' AND DATE_ADD('$year-$mon-$mday', INTERVAL 1 DAY)");
	}
	my $WHERE=join(" AND ",@WHERE);
	$WHERE="WHERE ".$WHERE if $WHERE;
	my $logdata;
	my $sql="SELECT * FROM ${PREF}log $WHERE ORDER by pk_log ASC";
	my $out=$db->prepare($sql);
	$out->execute();
	&Error($sql);
	unless ($out->rows()){
		$logdata.=<<ALL__;
                <tr class="data"> 
                  <td align="center" class="data" colspan=2><b>No logs found</b></td>
                </tr>
ALL__
	}
	while (my %output=%{$out->fetchrow_hashref}){
		$logdata.=<<ALL__;
                <tr class="data"> 
                  <td width="15%" align="right" class="data"><b><NOBR>$output{date}</NOBR></b></td>
                  <td width="54%" align="left">${\&sequre($output{log})}</td>
                </tr>
ALL__
	}
	
	$page->add_regesp('{allcountlog}',GetSQLCount("SELECT * FROM ${PREF}log"));
	$page->add_regesp('{logdata}',$logdata);
	$page->ParseData;
	return $page->as_string;

}
################
sub print_settings{
	my %map;
	%map=(	""       =>\&print_settings_main,
		personal  =>\&print_settings_personal,
		smtp     =>\&print_settings_smtp,
		pass     =>\&print_settings_pass,
		timecorr    =>\&print_settings_timecorr,
		'log'    =>\&print_settings_log,
		test    =>\&print_settings_test

	);
	$main_page=new dparser(
		DATA=>"$SHABL_DIR/main-settings.html"
	);
	$main_page->add_regesp('{main_menu}',get_account_menu(\@SETTINGSMENU));
	my $func_ref;
	if ($map{$PAR{act2}}) {
		$func_ref=$map{$PAR{act2}};
	}else{
		$func_ref=sub{return $q->h1("Please do not experiment with URL")}
	}
	$main_page->add_regesp('{body}',&$func_ref);
	$main_page->ParseData;
	&printheader;
	$main_page->print;	
}
#################
#################
##ACCOUNT
#################
#################
#USERS
#################
sub print_user_form{
	local @FIELDS;
	@FIELDS=load_account_fields($PAR{account});
	my $page = new hfparser(
		DATA=>$main_shabl,
		ERROR_AFTER_INPUT=>1
	);	
	if ($PAR{issubmit}){
		#SET ERROR
		$page->set_error("email","Email is incorrect") unless checkemail($PAR{email});
	        $page->set_error("email","Email <B>$PAR{email}</b> is already exists")		
		  if GetSQLCount("SELECT * from ${PREF}user where fk_account=? AND email=? AND pk_user<>?",$PAR{account},$PAR{email},$PAR{reckey});
		if ($PAR{days}=~/[^0-9]/){
			$page->set_error("days","Must be the number");
		}  
		$PAR{days}=0 unless $PAR{days};
		unless($page->is_error){
			my $last;
			unless($PAR{reckey}){
				$last=GetLastInsert("${PREF}user");
				$db->do("INSERT INTO ${PREF}user (fk_account,name,email,days,datereg) VALUES (?,?,?,?,$NOW)",undef,$PAR{account},$PAR{name},$PAR{email},$PAR{days});
				&Error;
			}else{
				#update user
				update_db("${PREF}user",{fk_account=>$PAR{account},name =>$PAR{name},email=>$PAR{email},days=>$PAR{days}},{pk_user=>$PAR{reckey}});
				$last=$PAR{reckey};
			}
			
			foreach(@FIELDS){
				my $param="dp".$_->{key};
				save_user_parametr($_->{key},$last,$PAR{$param});
			}
			print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=users&account=$PAR{account}");
			exit(1);
		}
	}
	#set defaults
	if ($PAR{reckey}){
		$page->add_regesp('{mode}', "Edit");
		$val=select_one_db("SELECT * from ${PREF}user WHERE pk_user=? and fk_account=?",$PAR{reckey},$PAR{account}) 
		  || die "ERROR: bed request USER not found";
		$page->set_def('email',$val->{email});
		$page->set_def('name',$val->{name});
		$page->set_def('days',$val->{days});
		foreach (@FIELDS){
			$page->set_def('dp'.$_->{key},get_user_parametr($_->{key},$PAR{reckey}));
		}
	}else{
		$page->set_def('days',0);
		$page->add_regesp('{mode}', "New");
	}
	my $add;
	foreach (@FIELDS){
		$add.=<<ALL__;
		<TR class="data">
		<td align="right"><b>$_->{name}:</b></td>
		<TD>{fm_$_->{type}_dp$_->{key}}</TD></TR>
ALL__
	}
	$page->ChangeData('{additional_fields}',$add);
	$page->SplitData("#begin#user_form","#end#user_form");
	$page->deleteBEFORE_AFTER();
	$page->set_default_input("text","size",35);
	$page->set_default_input("textarea","rows",4);
	$page->set_default_input("textarea","columns",35);
	$page->set_input("days",{size=>3,maxlength=>3});
	$page->ParseData;
	return $page->as_string;
}
#############
sub print_user_browser{
	my $OUT;
	my @showfields=$q->param("showfields");
	my @showadditional=$q->param("additional");
	my %FIELDS;
	map{$FIELDS{$_->{key}}=$_->{name}}@FIELDS;
	my @addtdfield=map{"<TD><NOBR>$FIELDS{$_}</NOBR></TD>"}@showfields;
	my @addtdextra=map{"<TD><NOBR>$summary{$_}</NOBR></TD>"}@showadditional;
	my @WHERE=();
	my $ORDER, $LEFTJ;
	push(@WHERE,"fk_account=".$db->quote($PAR{account}));
	if ($PAR{usedate}){
		push(@WHERE,"datereg BETWEEN ".$db->quote("$PAR{year1}-$PAR{month1}-$PAR{day1}")." AND ".$db->quote("$PAR{year2}-$PAR{month2}-$PAR{day2}"));
	}
	$PAR{doprar}="email" unless($PAR{doprar});
	$PAR{ordertype}="ASC" unless($PAR{ordertype});
	if (($PAR{doprar} eq "email") or ($PAR{doprar} eq "name")){
		$ORDER = "ORDER by $PAR{doprar} $PAR{ordertype}";
		push(@WHERE,"$PAR{doprar} LIKE ".$db->quote("%".$PAR{search}."%")) if ($PAR{search} ne "");
	}else{
		$LEFTJ="LEFT JOIN ${PREF}doppar ON fk_user=pk_user AND fk_fields=$PAR{doprar}";	
		$ORDER = "ORDER by value $PAR{ordertype}";
		push(@WHERE,"value LIKE ".$db->quote("%".$PAR{search}."%")) if ($PAR{search} ne "");
	}
	if ($PAR{filter} eq "act"){
		push(@WHERE, "isact=1");
	}elsif($PAR{filter} eq "dis"){
		push(@WHERE, "isact=0");	
	}elsif($PAR{filter} eq "ec"){
		if(@messdays){
			my $lastid=$messdays[scalar(@messdays)-1];
			push(@WHERE, "messlastsend=$lastid");	
		}	
	}elsif($PAR{filter} eq "pend"){
		my @pend = @{$db->selectcol_arrayref("select fk_user from ${PREF}doiaccounts")};
		if (@pend){
			push(@WHERE, "pk_user IN (".join(",",@pend) .")");	
		}
	}
	
	my $WHERE;
	if (@WHERE){
		$WHERE="WHERE ".join(" AND ", @WHERE);
	}
	$sql="SELECT * FROM ${PREF}user $LEFTJ $WHERE $ORDER";
	my $i=0;
	my %addt=();
	map{$addt{$_}=1}@showadditional;
	my @addt=();
	foreach(@summary){
		push(@addt,$_) if exists($addt{$_});
	}
	my $allcount=GetSQLCount($sql);
	my $allpages=20;
	$PAR{p2}=1 unless $PAR{p2};
	my $maxpages=20;
	my $pages=ceil($allcount/$PAR{onpage});
	$PAR{page}=1 unless $PAR{page};
	my $alluserscount=GetSQLCount("SELECT * from ${PREF}user WHERE fk_account=?",$PAR{account});
	if ($pages>1){
		my $start=$PAR{onpage}*($PAR{page}-1);
		my $rows=$PAR{onpage};	
		$sql=$sql." LIMIT $start, $rows";
		$OUT.="<DIV align = \"left\">Page <B>$PAR{page}/$pages</b> (prospects <B>$PAR{onpage}/$allcount</B>):";
		my $startpage=($PAR{p2}-1)*$maxpages+1;
		my $endpage=$PAR{p2}*$maxpages;
		$endpage=$pages if ($endpage>$pages);
		my $count_pages_pages=ceil($pages/$maxpages);
		$OUT.=" ".$q->a({-href=>get_full_url({page=>($PAR{p2}-2)*$maxpages+1,p2=>$PAR{p2}-1})},"<<[$maxpages]Previous")." " if ($PAR{p2} >1);
		foreach($startpage..$endpage){
			$OUT.=" ".$q->a({-href=>get_full_url({page=>$_,p2=>$PAR{p2}})},$_)." " unless ($PAR{page} eq $_);
			$OUT.=" <B>$_</B> " if ($PAR{page} eq $_);
		}
		$OUT.=" ".$q->a({-href=>get_full_url({page=>($PAR{p2})*$maxpages+1,p2=>$PAR{p2}+1})},"Next[$maxpages]>>")." " if ($PAR{p2} < $count_pages_pages);
		$OUT.="</DIV>";
	}else{

		if ($allcount == $alluserscount){
			$OUT.= "<H2>Showing $alluserscount prospects</H2>";
		}else{
			$OUT.= "<H2>Showing $allcount from $alluserscount prospects</H2>";
		}

	}
#$page->add_regesp('{sql}',"<BR>$sql<BR>PAGES: $pages");
	$page->add_regesp('{sql}',"");
	my $out=$db->prepare($sql);
	&Error;
	$out->execute();
	&Error;
	unless($out->rows){
		$page->SplitData("<!--START_RESULT-->","<!--END_RESULT-->");
		$page->replaceINSIDE($q->h1("NO RECORDS FOUND"));
		return;
	}

	$OUT.= <<ALL__;
<table width="100%" border="0" cellspacing="2" cellpadding="2" align="center">
<TR class="dataheader">
<TD>#</TD>
<TD>&nbsp;</TD>
<TD>Email</TD>
<TD>Name</TD>
@addtdextra
@addtdfield
</TR>
ALL__
$i=$PAR{onpage}*($PAR{page}-1);
while (my %output=%{$out->fetchrow_hashref}){
	$i++;
	map{$output{$_}=sequre($output{$_})}keys %output;
	my %addshow;
	$addshow{status}="active" if $output{isact};
	$addshow{status}="inactive" unless $output{isact};
	if (($addshow{status} eq "inactive") and GetSQLCount("SELECT * FROM ${PREF}doiaccounts WHERE fk_user=$output{pk_user}")){
		$addshow{status}="pending"
	}
	$addshow{regdate}=$output{datereg};
	$addshow{sendcount}=$output{countsend};
	$addshow{cycle}=$messdays{$output{messlastsend}}.'/'.scalar(@messdays);
	my @addtdextra=map{"<TD align=\"center\"><NOBR>$addshow{$_}</NOBR></TD>"}@addt;
	my @addtdfield=map{"<TD>".get_user_parametr($_,$output{pk_user})."</TD>"}@showfields;
	$USERNAME=$output{name};
	$USERNAME=$CONF{defname} if ($USERNAME eq '');
	$OUT.= <<ALL__;
<TR class="data">
<TD>$i</TD>
<TD><INPUT type="checkbox" name="sel" value="$output{pk_user}"></TD>
<TD><a href="$SCRIPT_NAME?ses=$PAR{ses}&account=$PAR{account}&act=$PAR{act}&act2=userform&reckey=$output{pk_user}" title="Edit user">$output{email}</a></TD>
<TD><NOBR><a href="$SCRIPT_NAME?ses=$PAR{ses}&account=$PAR{account}&act=$PAR{act}&act2=userform&reckey=$output{pk_user}" title="Edit user">$USERNAME</a></NOBR></TD>
@addtdextra
@addtdfield
</TR>
ALL__

}

$OUT.= <<ALL__;
</TABLE>
ALL__
return $OUT;
}
###############
sub print_users{
	local $alluserscount=GetSQLCount("SELECT * from ${PREF}user WHERE fk_account=?",$PAR{account});
	local @FIELDS=load_account_fields($PAR{account});
	local %summary=(sendcount=>"Sent",status=>"Status",regdate=>"Date",cycle=>"Cycle");
	local @summary=qw(status cycle sendcount regdate);
	local @messdays,%messdays;
	$sql="SELECT * FROM ${PREF}mess WHERE fk_account = ? AND typesend = 'auto' ORDER BY days ASC";
	my $out=$db->prepare($sql);
	$out->execute($PAR{account});&Error($SQL);
	my $i=0;
	while (my %output=%{$out->fetchrow_hashref}){
		$i++;
		push @messdays,$output{pk_mess};
		$messdays{$output{pk_mess}}=$i;
	}
	$messdays{""}=0;
	local $page = new hfparser(
		DATA=>$main_shabl,
		ERROR_AFTER_INPUT=>0);
	$page->add_regesp("{mess}","");
	if ($PAR{bnRemove}){
		my @selected=$q->param("sel");
		if (@selected){
			@selected=map{$db->quote($_)}@selected;
			my $in=join(" , ",@selected);
			my $count=$db->do("DELETE FROM ${PREF}user WHERE pk_user IN ($in)");
			$page->add_regesp("{mess}","<h1 class=\"mess\">$count users removed</h1>");
			$db->do("DELETE FROM ${PREF}doppar WHERE fk_user IN ($in)");
			$db->do("DELETE FROM ${PREF}tosend WHERE fk_user IN ($in)");			
			$db->do("DELETE FROM ${PREF}doiaccounts WHERE fk_user IN ($in)");						
			&Error;
		}
	}
	if ($PAR{bnInvStat}){
		my @selected=$q->param("sel");
		if (@selected){
			@selected=map{$db->quote($_)}@selected;
			my $in=join(" , ",@selected);
			my $count=$db->do("UPDATE  ${PREF}user SET isact=IF(isact=0,1,0) WHERE pk_user IN ($in)");
			&Error;
			$page->add_regesp("{mess}","<h1 class=\"mess\" >$count users changed</h1>");
		}
	}
	
	unless($PAR{issubmit}){
	       $q->param(-name=>'onpage',-value=>'50');
       	       $page->set_def("onpage",50);$PAR{onpage}=50;
	       $q->param(-name=>'additional',-value=>[qw(status  cycle sendcount)]);	
		
	}	
	
	$page->add_regesp('{all_users_count}',$alluserscount);
	$page->add_regesp('{result_table}',&print_user_browser);
	$page->add_regesp('{account}',$PAR{account});
	$page->add_element("doprar",'email',"Email");	
	$page->add_element("doprar",'name',"Name");
	foreach (@FIELDS){
		$page->add_element("doprar",$_->{key},$_->{name});
	}
	foreach (qw(20 30 50 75 100 150 200 300 400)){
		$page->add_element("onpage",$_);
	}
	my $toshow;
	if (@FIELDS){
		$toshow.="<BR><B>Show fields:</b>";
		my @val=map{$_->{key}}@FIELDS;
		my %lab;
		map{$lab{$_->{key}}="$_->{name}"}@FIELDS;
		$toshow.=$q->checkbox_group(-name=>'showfields',
                                -values=>\@val,
                                -default=>"",
                                -labels=>\%lab);
	}
	my $additional;
	if (%summary){
		$additional.="<B>Show extra:</b>";
		my @val=@summary;
		map{$_->{key}}@FIELDS;
		$additional.=$q->checkbox_group(-name=>'additional',
                                -values=>\@val,
                                -default=>"",
                                -labels=>\%summary);
	}
	$page->add_regesp('{additional}',$additional);
	$page->add_regesp('{toshow_line}',$toshow);
	$page->add_element("ordertype","ASC","Ascending");
	$page->add_element("ordertype","DESC","Descending");	
	#DATE
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($MY_TIME);
	$year+=1900;$mon++;
	foreach (1..31){
		my $dd=sprintf("%02d",$_);
		$page->add_element("day1",$_,$dd);
		$page->add_element("day2",$_,$dd)
	}
	$page->set_def("day1",$mday);	$page->set_def("day2",$mday);
	my @month=qw(January February March April May June July August September October November December);
	foreach (1..12){
		$page->add_element("month1",$_,$month[$_-1]);$page->add_element("month2",$_,$month[$_-1]);
	}
	$page->set_def("month1",$mon);	$page->set_def("month2",$mon);
	foreach (2002..$year){
		$page->add_element("year1",$_);
		$page->add_element("year2",$_);
	}
	$page->set_def("year1",$year);	$page->set_def("year2",$year);
	$page->add_element("filter","","all");
	$page->add_element("filter","act","active");
	$page->add_element("filter","dis","inactive");	
	$page->add_element("filter","pend","pending");
	$page->add_element("filter","ec","finished");		
	#END DATE
	#SET DEF
	$page->SplitData("#begin#users","#end#users");
	$page->deleteBEFORE_AFTER();
	unless($alluserscount){
		$page->SplitData('<!--start_browser-->','<!--end_browser-->');
		$page->deleteINSIDE;
	}else{
	}
	$page->ParseData;
	return $page->as_string;

}
#################
#FIELDS
#################
sub sort_fields{
	my $account=shift;
	$sql="SELECT * from ${PREF}fields WHERE fk_account=? ORDER by rang ASC";
	my $out=$db->prepare($sql);
	&Error;
	$out->execute($PAR{account});
	&Error;
	my $i;
	while (my %output=%{$out->fetchrow_hashref}){
		$i++;
		update_db("${PREF}fields",{rang=>$i},{pk_fields=>$output{pk_fields}});
		&Error;
	}
}
################
sub delete_field{
	$db->do("DELETE FROM ${PREF}fields WHERE fk_account=? AND pk_fields=?",undef,$PAR{account},$PAR{reckey});
	$db->do("DELETE FROM  ${PREF}doppar WHERE fk_fields=",undef,$PAR{reckey});
	sort_fields($PAR{account});
	print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=columns&account=$PAR{account}");
	exit(1);
}
####################
sub print_field_form{
	my $ischecked_isreq;
	my %error;
	my %INPUT;	
	my $page = new hfparser(
		DATA=>$main_shabl,
		ERROR_AFTER_INPUT=>1
		
	);	
	if ($PAR{issubmit}){
		$page->set_error("fieldname","Field name is incorrect") if $PAR{fieldname}=~/[^a-zA-Z 0-9_\-.:]/;
		$page->set_error("fieldname","Field name $PAR{fieldname} is already used")
		  if GetSQLCount("SELECT * from ${PREF}fields where fk_account=? AND fieldname=? AND pk_fields<>?",$PAR{account},$PAR{fieldname},$PAR{reckey});
		$page->set_error("fieldname","Field name $PAR{fieldname} is reserved") 
		     if ($PAR{fieldname}=~/^name *$/i) or ($PAR{fieldname}=~/^email *$/i);
		$page->set_error("fieldname","Field name is empty") unless $PAR{fieldname};
	}
	if ($PAR{issubmit} && !$page->is_error){
		unless($PAR{reckey}){
			##Add new
			my $isreq;
			$rang1=GetSQLCount("SELECT * from ${PREF}fields where fk_account=?",$PAR{account});
			sort_fields($PAR{account});
			insert_db("${PREF}fields",{type=>$PAR{type},fieldname=>$PAR{fieldname},fk_account=>$PAR{account},is_req=>$PAR{isreq}, rang=>$rang1+1});	
			print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=columns&account=$PAR{account}");
			
			exit(1);
		}else{	
			sort_fields($PAR{account});
			update_db("${PREF}fields",{fieldname=>$PAR{fieldname},fk_account=>$PAR{account},is_req=>$PAR{isreq},type=>$PAR{type}},{pk_fields=>$PAR{reckey}});	
			print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=columns&account=$PAR{account}");
			exit(1);
		}
	}
	####
	#set defaults
	####
	if ($PAR{reckey}){
		$val=select_one_db("SELECT * from ${PREF}fields WHERE pk_fields=?",$PAR{reckey}) || die "Atantion: bed request field  $PAR{reckey} not found";
		$page->set_def('fieldname',$val->{fieldname});
		$page->set_def('type',$val->{type});
		$page->set_def('isreq',$val->{is_req});		
	}
	$page->add_element("type","text","TEXT");
	$page->add_element("type","textarea","TEXTAREA");	
	$page->set_input('isreq',{-value=>'1' -checked=>$ischecked_isreq});
	$page->SplitData("#begin#column_form","#end#column_form");
	$page->deleteBEFORE_AFTER();	
	$page->add_regesp('{body}',&print_columns_browser);
	$page->ParseData;
	return $page->as_string;
}
###################
sub print_add_accounts{
my $OUT;
my %account=%ACCOUNT;
delete $account{$PAR{account}};
return unless %account;
my @add;
foreach (keys %account){
$OUT.="<LI>".sequre("<input type=\"hidden\" name=\"addaccount\" value=\"$_\">")." - for account <B>$account{$_}</B>";
}
if ($OUT){
$OUT=<<ALL__;
<HR noshade size="4"><H2>To automatically add users to another account put that tags<br>into your form right before the &lt;/form&gt; tag</H2>
<DIV align="left"><UL>
$OUT
</UL>
</DIV>
ALL__
}
return "$OUT";
}
####################
sub print_columns_browser{
my $ret;
my $defsize=25;
my $rowssize=5;
my $max=80;
my $def_class="INPUTmy";
my $def_over_class="INPUTmyACT";
my @deftextfield=(-size=>$defsize,-maxlength=>$max,-class=>$def_class,
			-onFocus=>"this.className ='$def_over_class' ; return true;",
 			-onBlur=>" this.className ='$def_class'");			    
my @deftextarea=(-rows=>$rowssize,-columns=>$defsize,-class=>$def_class,
			-onFocus=>"this.className ='$def_over_class' ; return true;",
 			-onBlur=>" this.className ='$def_class'");			    
my $add_new_link=$q->a({-href=>get_full_url({act2=>fieldform,reckey=>""})},'Click here to add new field');
	my $sql="select * from ${PREF}fields where fk_account=? order by rang";
	my $out=$db->prepare($sql);
	$out->execute($PAR{account});
	&Error;
	my $namefield=$q->textfield(
			-name=>'name',
                        -default=>'Jon Doe',@deftextfield
   		    );
	my $emailfield=$q->textfield(
			-name=>'email',
                        -default=>'email@host.com', @deftextfield
		    );		    
	$ret.=<<ALL__;
	<TABLE width="100%" border="0" cellspacing="3" cellpadding="3" align="center"> 
<TR class="data">
	<TD align="right"><B>Name:</B></TD>
	<TD>$namefield <FONT color="red">*</FONT></TD>
	<TD colspan="3" align="center">Reserved</TD>
</TR>
<TR class="data">
	<TD align="right"><B>Email:</B></TD>
	<TD>$emailfield <FONT color="red">*</FONT></TD>
	<TD colspan="3" align="center">Reserved</TD>
</TR>
ALL__
	unless ($out->rows){
		$ret.="</TABLE>$add_new_link";
		return $ret;
	}
	my $rows=$out->rows;
	$ret.=<<ALL__;
<TR class="data">
	<TD colspan="5" align="center">You have <B>$rows</B> custom field(s)</TD>
</TR>
ALL__
	while (my %output=%{$out->fetchrow_hashref}){
		my $field;
		$field=$q->textfield(-name=>"df$output{pk_fields}", @deftextfield) if ($output{type} eq 'text');
		$field=$q->textarea(-name=>"df$output{pk_fields}", @deftextarea) if ($output{type} eq 'textarea');		
		my $editlink=$q->a({-href=>get_full_url({act2=>'fieldform',reckey=>$output{pk_fields}})},'Edit');
		my $onCL=<<ALL__;
return confirm('Are you sure you want to delete this field? Some data can be lost!');		
ALL__
		my $droplink=$q->a({-onClick=>$onCL,
				-href=>get_full_url({act2=>'delfield',reckey=>$output{pk_fields}})},'Drop');
		my $uplink=  $q->a({-href=>get_full_url({act2=>'up',reckey=>$output{pk_fields}})},'UP') if $output{rang}>1;
		$uplink="UP" unless $output{rang}>1;		
		my $downlink=$q->a({-href=>get_full_url({act2=>'down',reckey=>$output{pk_fields}})},'DOWN') if $output{rang} < $out->rows;
		$downlink="DOWN" unless $output{rang} < $out->rows;
		my $isreq="<FONT color=\"red\">*</FONT>" if $output{is_req};
		$ret.=<<ALL__;
<TR class="data">
	<TD align="right"><B>$output{fieldname}:<B></TD>
	<TD>$field $isreq</TD>
	<TD>$editlink</TD>
	<TD>$droplink</TD>
	<TD>Move $uplink | $downlink</TD>	
</TR>
ALL__
	}
	$ret.=<<ALL__;
	</TR></TABLE>
$add_new_link
ALL__
return $ret;
}
###################
sub get_html_code{
	my $account=shift;
	my $html;
	$account=$PAR{account} unless $account;
	my $address=$ENV{HTTP_HOST};
	my $scriptdir=$ENV{SCRIPT_NAME};
	(my $src=$scriptdir)=~s#[^/]*$##;
	$html=<<ALL__;
<!-- Start form -->
<form name="mailform" method="post" action="http://$address${src}register.cgi">
  <table width="80%" border="0" cellspacing="0" cellpadding="4">
   <tr>
    <td align="right" width="50%"><b>Name:</b></td>
    <td width="50%">
     <input type="text" name="name" size="25" maxlength="40">
     <font color="red">*</font> 
     <input type="hidden" name="account" value="$account">
    </td>
   </tr>
   <tr> 
    <td align="right" width="50%"><b>Email:</b></td>
    <td width="50%">
     <input type="text" name="email" size="25" maxlength="40">
     <font color="red">*</font> 
    </td>
   </tr>
ALL__
	
	$sql="SELECT * from ${PREF}fields WHERE fk_account=? ORDER by rang";
	my $out=$db->prepare($sql);
	
	&Error;
	$out->execute($account);
	&Error;
	while (my %output=%{$out->fetchrow_hashref}){
		my $isrec;
		my $innput;
		if ($output{type} eq 'text'){
			$innput=<<ALL__;
 <input type="text" name="dp$output{pk_fields}" size="25" maxlength="40">
ALL__
		}else{
	$innput=<<ALL__;
 <TEXTAREA name="dp$output{pk_fields}" rows="4" columns="25">
 </TEXTAREA>
ALL__

		}
		$isrec="<font color=\"red\">*</font>" if ($output{is_req} ==1);
		$html.=<<ALL__;
 <tr> 
  <td align="right" width="50%"><b>$output{fieldname}:</b></td>
   <td width="50%">
     $innput $isrec 
  </td>
 </tr>
ALL__
	}

$html.=<<ALL__;	
 <tr> 
   <td align="center" colspan="2"> <input type="submit" value="Subscribe"></td>
 </tr>
 </table>
              </form>
<!-- End form -->
ALL__
	
	return $html;
}
###################
sub print_columns{
	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	sort_fields($PAR{account});
	$page->SplitData("#begin#column_browser","#end#column_browser");
	$page->set_input('htmlcode',{columns=>80,default=>get_html_code($PAR{account})});
	$page->add_regesp('{formPrewiew}',get_html_code($PAR{account}));
	$page->deleteBEFORE_AFTER();	
	$page->add_regesp('{body}',&print_columns_browser);
	$page->add_regesp('{ADDACCOUNTS}',&print_add_accounts);
	$page->ParseData;
	return $page->as_string;
}
#############
sub get_user_parametr{	
my $field=shift;
my $user=shift;
my $out;
my $out=select_one_db("SELECT * from ${PREF}doppar WHERE fk_fields=? AND fk_user=?",$field,$user);
return $out->{value};
}
####################
sub print_config{
	my %httppars=(redirsub=>1, redirrem=>0,doiconfurl=>0);
	my @params=(qw(defname subscribeemail pop3server pop3user pop3pass pop3port fromname fromemail  isaddunsubscrlink ispurge isnotifsubscr isnotifunsubscr isdoi doiconfurl ispop3),keys %httppars);
	my @req=(qw(defname fromemail fromname redirsub redirrem));
	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	if ($PAR{issubmit}){
		if($PAR{ispop3}){
			push(@req,qw(pop3server pop3user pop3pass pop3port subscribeemail))
		}
		$httppars{doiconfurl}=1 if $PAR{isdoi};
		$httppars{redirrem}=1 if $PAR{isaddunsubscrlink};
		foreach (keys %httppars){
			$page->set_error($_,"URL is incorrect") unless check_url($PAR{$_},$httppars{$_});
		}
		foreach (@req){
			$page->set_error($_,"Is required") if ($PAR{$_} eq '');
		}
		$page->set_error("fromemail","Incorrect email") unless (checkemail($PAR{fromemail},0));
		if ($PAR{pop3port}){
			if ($PAR{pop3port}=~/[^0-9]/){
				$page->set_error('pop3port',"Must be the number");
			}
		}
		unless ($page->is_error){
			foreach(@params){
				#$PAR{$_}=~s/^(http:\/\/+)+// if exists($httppars{$_});
				save_config($PAR{account},$_,$PAR{$_});
			}
			$page->add_regesp('{error}', '<h1 class="mess">Account settings updated!</h1>');
		}
	}
	foreach (@params){
		if (exists($httppars{$_})){
			$CONF{$_}="http://" unless $CONF{$_};
		}
		
		$page->set_def($_,$CONF{$_});
	}
	####
	$page->set_default_input("text","size",35);
	$page->set_input("pop3port",{size=>4, MAXLENGTH=>5});
	$page->SplitData("#begin#config","#end#config");
	$page->deleteBEFORE_AFTER();	
	$page->ParseData;
	return $page->as_string;
}
####################
sub print_main_account_data{

	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	$page->SplitData("#begin#main","#end#main");
	$page->deleteBEFORE_AFTER();
	$page->add_regesp('{account}',$PAR{account});
	$page->add_regesp('{total_prospects}',GetSQLCount("Select * from ${PREF}user WHERE fk_account=?",$PAR{account}));
	$page->add_regesp('{total_active}',GetSQLCount("Select * from ${PREF}user WHERE fk_account=? AND  isact=1",$PAR{account}));
	$page->add_regesp('{total_inactive}',GetSQLCount("Select * from ${PREF}user WHERE fk_account=? AND  isact<>1",$PAR{account}));
	$page->ParseData;
	return $page->as_string;
}
#first for account
##########################
sub move_down_field{
sort_fields($PAR{account});
my $el=select_one_db("SELECT * from ${PREF}fields WHERE pk_fields=?",$PAR{reckey});
my $rang=$el->{rang};
my $count= GetSQLCount("SELECT * from ${PREF}fields WHERE fk_account=?",$PAR{account});
if ($rang<$count){
 	$db->do("UPDATE ${PREF}fields Set rang=$rang WHERE fk_account=? and rang=$rang+1",undef, $PAR{account});
	&Error;
	$db->do("UPDATE ${PREF}fields Set rang=rang+1 WHERE pk_fields=?",undef, $PAR{reckey});
	&Error; 
}
sort_fields($PAR{account});
print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=columns&account=$PAR{account}");
exit();
}
#######################
sub move_up_field{
sort_fields($PAR{account});
my $el=select_one_db("SELECT * from ${PREF}fields WHERE pk_fields=?",$PAR{reckey});
my $rang=$el->{rang};
my $count= GetSQLCount("SELECT * from ${PREF}fields WHERE fk_account=?",$PAR{account});
if ($rang>1){
 	$db->do("UPDATE ${PREF}fields Set rang=$rang WHERE fk_account=? and rang=$rang-1",undef, $PAR{account});
	&Error;
	$db->do("UPDATE ${PREF}fields Set rang=rang-1 WHERE pk_fields=?",undef, $PAR{reckey});
	&Error; 
}
sort_fields($PAR{account});
print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=columns&account=$PAR{account}");
exit();
}
######################
sub print_users_loadfrom{
	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	$page->SplitData("#start#user_loadfrom","#end#user_loadfrom");
	$page->deleteBEFORE_AFTER;
	if($PAR{issubmit}){
		my $add;
		$add="AND isact='1'" if ($PAR{activ} eq 'act');
		$add="AND isact='0'" if ($PAR{activ} eq 'dis');
		my $sql="SELECT * FROM ${PREF}user WHERE fk_account=?  $add";
		my $out=$db->prepare($sql);
		$out->execute($PAR{'import'});
		my @OUT=();
		while (my %output=%{$out->fetchrow_hashref}){
			delete($output{pk_user});
			$output{fk_account}=$PAR{account};
			insert_db("${PREF}user",\%output) unless GetSQLCount("SELECT * FROM ${PREF}user WHERE fk_account=? AND email=?",$PAR{account},$output{email});
		}
		print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=users&account=$PAR{account}");
		exit;
	}
	$page->add_element("activ","","all");
	$page->add_element("activ", "act", "active");
	$page->add_element("activ", "dis", "inactive");
	my $sql="SELECT ${PREF}account.name as name,${PREF}account.pk_account as reckey, count(pk_user) as mycount  FROM  ${PREF}account LEFT JOIN  ${PREF}user ON fk_account=pk_account  WHERE pk_account <> ? GROUP BY fk_account HAVING mycount>0";
	my $out=$db->prepare($sql);
	$out->execute($PAR{account});
	&Error($sql);
	unless($out->rows){
		$page->SplitData("<!--START_RESULT-->","<!--END_RESULT-->");
		$page->replaceINSIDE("<h1 class=\"mess\">Can not import - found 0 prospects in another accounts</H1>");
		
	}
	while (my %output=%{$out->fetchrow_hashref}){
		$page->add_element("import",$output{reckey},"$output{name} [$output{mycount}]");
	}
		
	
	$page->ParseData;
	return $page->as_string;	
}
######################
sub print_users_export{
	my $allcount=GetSQLCount("SELECT * FROM ${PREF}user WHERE fk_account=? AND isact=1",$PAR{account});
	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	$page->SplitData("#start#user_export","#end#user_export");
	$page->deleteBEFORE_AFTER;
	if($PAR{issubmit}){
		my $add;
		$add="AND isact='1'" if ($PAR{activ} eq 'act');
		$add="AND isact='0'" if ($PAR{activ} eq 'dis');
		my $sql="SELECT * FROM ${PREF}user WHERE fk_account=?  $add";
		my $out=$db->prepare($sql);
		&Error;
		$out->execute($PAR{account});
		&Error;
		my @OUT=();
		while (my %output=%{$out->fetchrow_hashref}){
			my $shabl=$PAR{format};
			$shabl=~s/TAB/\t/;
			$shabl=~s/--email--/$output{email}/;
			$shabl=~s/--name--/$output{name}/;
			push(@OUT,$shabl);
		}
		if ($PAR{to} eq 'file'){
			print "Content-type: application/octet-stream\nContent-Disposition: attachment; filename=prospects.txt\n\n";
			print join("\n",@OUT);
			exit;
		}else{
			@OUT=map{sequre($_)}@OUT;
			$page->SplitData("<!--START_RESULT-->","<!--END_RESULT-->");
			$page->replaceINSIDE($q->h1("Exported ".$out->rows." prospects").join("<BR>\n",@OUT));
		}
	}
	unless($allcount){
		$page->SplitData("<!--START_RESULT-->","<!--END_RESULT-->");
		$page->replaceINSIDE($q->h1("Can not export - found 0 prospects"));
	}	
	$page->add_regesp('{all_count}',$allcount);
	$page->add_regesp('{account}',$PAR{account});
	$page->add_element("activ","","all");
	$page->add_element('activ', 'act', 'active');
	$page->add_element('activ', 'dis', 'inactive');

	$page->add_element("format","--email--","EMAIL only");
	$page->add_element("format","--name-- --email--","NAME EMAIL");	
	$page->add_element("format","<--name--> --email--","<NAME> EMAIL");		
	$page->add_element("format","\"--name--\" --email--","\"NAME\" EMAIL");	
	$page->add_element("format","--name--|--email--","NAME|EMAIL");		
	$page->add_element("format","--name--:--email--","NAME:EMAIL");		
	$page->add_element("format","--name--,--email--","NAME,EMAIL");			
	$page->add_element("format","--name--TAB--email--","NAME<TAB>EMAIL");
	$page->add_element("to","file","file");
	$page->add_element("to","here","page"); 
	$page->set_def("to","here");
	$page->ParseData;
	return $page->as_string;
}


#######################
sub print_users_bulk{
my $page = new hfparser(
		DATA=>$main_shabl		
	);
my @quer;	
if ($PAR{issubmit}){
	@quer=split(/\n/,$PAR{bulk});
	map{s/\s+//g}@quer;
	map{s/\*/%/g}@quer;
	my @QUER;
	foreach(@quer){
		push @QUER, $_ if /[a-zA-Z0-9%.\-_@]/
	}
	unless (@QUER){
		$page->set_error("bulk","Bulk query is incorrect");
	}
	@quer=map{"(${PREF}user.email LIKE '\%$_\%')"}@QUER;
	my $WHERE;
	if ($PAR{accounts} eq 'all'){
		$WHERE=join(" OR ",@quer);
	}else{
		$WHERE="(".join(" OR ",@quer).") AND fk_account='$PAR{account}'";
	}
	unless ($page->is_error){
		$page->SplitData("#start#user_confirmbulk","#end#user_confirmbulk");
		$page->deleteBEFORE_AFTER;
		$page->add_regesp('{account}',$PAR{account});
		my $sql="SELECT * FROM ${PREF}user WHERE $WHERE";
		my $count=GetSQLCount($sql);
		$page->add_regesp('{countusers}',$count);
		unless($PAR{issubmit2}){
			$page->add_regesp('{status}','will be');
			unless($count){
				$page->SplitData("<!--startdel-->","<!--enddel-->");
				$page->deleteINSIDE;
			}
		}else{	
			$page->add_regesp('{status}','');
			my @users = @{$db->selectcol_arrayref("select pk_user from ${PREF}user WHERE $WHERE")};
			if (@users){
				my $in=join ",",@users;
				$db->do("DELETE FROM ${PREF}user WHERE pk_user IN ($in)");
				&Error;
				$db->do("DELETE FROM ${PREF}doppar WHERE fk_user IN ($in)");
				&Error;
				$db->do("DELETE FROM ${PREF}tosend WHERE fk_user IN ($in)");			
				&Error;
				$db->do("DELETE FROM ${PREF}doiaccounts WHERE fk_user IN ($in)");						
				&Error;
			}
			OPTIMIZEtables();
			$page->SplitData("<!--startdel-->","<!--enddel-->");
			$page->deleteINSIDE;
			
		}
		$page->ParseData;
		return $page->as_string;
	}
}
	$page->SplitData("#start#user_bulk","#end#user_bulk");
	$page->set_default_input("textarea","rows",12);	
	$page->set_default_input("text","size",3);		
	$page->set_default_input("textarea","columns",55);
	unless($PAR{issubmit2}){
		$page->add_element("accounts","this","Current account");
		$page->add_element("accounts","all","All accounts");
	}
	$page->add_regesp('{account}',$PAR{account});
	$page->deleteBEFORE_AFTER;
	$page->ParseData;
	return $page->as_string;
}
#######################
sub print_users_import{
my $page = new hfparser(
		DATA=>$main_shabl		
	);
if ($PAR{issubmit}){
	if($PAR{add_to} eq "prospects_active"){
		$page->set_error("interval","Must be the number") if ($PAR{interval}=~/[^0-9]/);
		$page->set_error("interval","Required") if ($PAR{interval} eq "");
	}
	my $days;
	if($PAR{add_to} eq "prospects_active"){
		$days=$PAR{interval};
	}else{
		$days=0;
	}
	unless ($page->is_error){
		my @str;
		if ($q->param("uploaded_file")){
			$fh=$q->upload("uploaded_file");
			@str=<$fh>;
			chomp(@str);
		}else{
			@str=split(/\n/,$PAR{import});
			chomp(@str);
		}
		my $i=0;
		my @errors;
		my $count=0;
		foreach (@str){
			$i++;
			s/([a-zA-Z0-9_.\-]+@[a-zA-Z0-9_.\-]+)//;
			my $mail = lc($1);
			unless ($mail){
				push (@errors, "Line $i: Can not find email");
				next;
			}
			unless (checkemail($mail)){
				push (@errors, "Line $i: email $mail is incorrect");
				next;
			}
			if (GetSQLCount("SELECT * FROM ${PREF}user WHERE email=? AND fk_account=?",$mail,$PAR{account})){
				push (@errors, "Line $i: email $mail is already exists");
				next;
			}
			s/[^A-Za-z.]/ /g;
			s/^ +//;s/ +$//;
			while (s/  / /g){}
			my @words=split(/ /);
			@words=map{ucfirst(lc($_))}@words;
			$name=join(' ',@words);
			$count++;
			$db->do("INSERT INTO ${PREF}user (fk_account,name,email,days,datereg) VALUES (?,?,?,?,$NOW)",undef,$PAR{account},preparename($name),prepareemail($mail),$days);		
			&Error;
		}
		my $out.=$q->h1("$count prospects added.");
		if (@errors){
			$out.=$q->h2(scalar(@errors)." errors detected");
			$out.=join "<BR>",@errors;
		}
		return $out;
	}
}
	$page->SplitData("#start#user_import","#end#user_import");
	$page->set_default_input("textarea","rows",12);	
	$page->set_default_input("text","size",3);		
	$page->set_default_input("textarea","columns",55);
	$page->set_def("add_to",0);
	$page->add_regesp('{account}',$PAR{account});
	$page->deleteBEFORE_AFTER;
	$page->ParseData;
	return $page->as_string;
	next
}
######################
sub print_personalize{
	my @FIELDS=map{"<LI><B>[ADD$_->{key}]</B> - $_->{name}"}load_account_fields($PAR{account});
	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	$page->SplitData("#start#personalize","#end#personalize");
	$page->deleteBEFORE_AFTER();
	$page->add_regesp('{additional}',"") unless @FIELDS;
	$page->add_regesp('{additional}',"<LI><B>Extra merge field words</b><UL>".join("\n",@FIELDS)."</UL>") if @FIELDS;
	$page->ParseData;
	return $page->as_string;
}
######################
sub print_account_newmess{
	my @req=qw(subject mess);
	my $page = new hfparser(
		DATA             =>$main_shabl,		
		ERROR_AFTER_TEMPL=>"<SPAN class=\"ERROR_ELEMENT\">&nbsp;&nbsp;&nbsp;&nbsp;###ERR###</SPAN>111111"
	);
	$page->SplitData("#start#user_newmess","#end#user_newmess");
	$page->deleteBEFORE_AFTER();
	$page->add_regesp('{error_date}',"");
	if ($PAR{issubmit}){
		foreach (@req){
			$page->set_error($_,"Is required") if ($PAR{$_} eq '');
		}
		if ($PAR{typesend} eq 'auto'){
			if ($PAR{days}=~/[^0-9]/){
				$page->set_error("days","not number");
			}elsif($PAR{days}>2000){
				$page->set_error("days","to long");
			}else{
				$page->set_error("days","<NOBR>is used<NOBR>") if GetSQLCount("SELECT * FROM ${PREF}mess WHERE fk_account=? and typesend='auto' AND days=? AND pk_mess<>'$PAR{reckey}'",$PAR{account},$PAR{days});
			}
		}
		if ($PAR{typesend} eq 'senddat'){
			my ($y,$m,$d)=($PAR{year}-1900,$PAR{month}-1,$PAR{day});
			my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($MY_TIME);
			my $timelocalsend=timelocal(0,0,0,$d,$m,$y);
			my $timelocalnow=timelocal(0,0,0,$mday+1,$mon,$year);
			$dif = $timelocalsend - $timelocalnow;
			if ($dif<0){
				$page->set_error("day"," ");
				$page->set_error("month"," ");
				$page->set_error("year"," ");				
				$page->add_regesp('{error_date}',"<NOBR><SPAN class=\"ERROR_ELEMENT\">Date is incorrect</SPAN><NOBR>");				
			}
		}

		unless ($page->is_error){
			my $id;
		
			my $days,$datesend;
			$days=0 unless ($PAR{typesend} eq 'auto');
			$days=$PAR{days} if ($PAR{typesend} eq 'auto');
			$datesend='' unless ($PAR{typesend} eq 'senddat');
			$datesend="$PAR{year}-$PAR{month}-$PAR{day}" if ($PAR{typesend} eq 'senddat');
			unless($PAR{reckey}){
				$id=insert_db("${PREF}mess",{subject =>$PAR{subject},mess=>$PAR{mess},
					type=>$PAR{type},typesend=>$PAR{typesend},
					fk_account=>$PAR{account},days=>$days,
					senddat=>$datesend});
			}else{
				update_db("${PREF}mess",
					{subject =>$PAR{subject},mess=>$PAR{mess},
					type=>$PAR{type},typesend=>$PAR{typesend},
					fk_account=>$PAR{account},days=>$days,
					senddat=>$datesend},
					{pk_mess=>$PAR{reckey}}
				);
				$id=$PAR{reckey};
				
			}
			
			if ($filename=$q->param('uploaded_file')){
				$file=$filename;
				$file=~s(^.*\\)();$file=~s(^.*/)();
				my $data;
				$fh=$q->upload("uploaded_file");
				binmode($fh);
				my $tmpdata;
				while(sysread $fh,$tmpdata,1024*10){$data.=$tmpdata};
				insert_db("${PREF}attach",{filename=>$file,data=>$data,fk_mess=>$id,len=>length($data)});
			}
			print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&act2=mess&account=$PAR{account}");
			exit();
		}
	}
	my $REPL;

	$page->set_def("days", 0);
	#DATE
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($MY_TIME);
	$year+=1900;$mon++;
	foreach (1..31){
		my $dd=sprintf("%02d",$_);
		$page->add_element("day",$_,$dd);
	}
	$page->set_def("day",$mday);
	my @month=qw(January February March April May June July August September October November December);
	foreach (1..12){
		$page->add_element("month",$_,$month[$_-1]);
	}
	$page->set_def("month",$mon);
	foreach ($year..$year+3){
		$page->add_element("year",$_);
	}
	$page->set_def("year",$year);
	
	$page->add_element("type","text","TEXT");
	$page->add_element("type","html","HTML");	

	unless($PAR{reckey}){
		$page->add_regesp("{header}","Creating the new message to account");
		$page->SplitData("###FORNEW###","###END_FORNEW###");
		$REPL= join "",$page->getINSIDE();
		$page->add_regesp("{attach}","");
	}else{
		$page->add_regesp("{header}","Edit message");
		my $mess=load_mess($PAR{reckey});
		$page->set_def("subject",$mess->{subject});
		$page->set_def("mess",$mess->{mess});
		$page->set_def("type",$mess->{type});
		$page->set_def("typesend",$mess->{typesend});
		if ($mess->{typesend} eq 'auto'){
			$page->SplitData("###FORAUTO###","###END_FORAUTO###");
			$REPL= join "",$page->getINSIDE();
			$page->set_def("days",$mess->{days});
		}elsif($mess->{typesend} eq 'manual' or $mess->{typesend} eq 'senddat' or $mess->{typesend} eq 'sent'){
			$PAR{typesend}=$mess->{typesend};
			
			$page->SplitData("###FORDATE###","###END_FORDATE###");
			$REPL= join "",$page->getINSIDE();
		}else{
			$PAR{typesend}=$mess->{typesend};
			$page->SplitData("###FORSUBSCR###","###END_FORSUBSCR###");
			$REPL= join "",$page->getINSIDE();
		}
		if ($mess->{typesend} eq 'senddat'){
			$page->set_def("day",$mess->{n_day});
			$page->set_def("month",$mess->{n_month});			
			$page->set_def("year",$mess->{n_year});						
		}
		if ($mess->{typesend} eq 'sent'){
			$PAR{typesend}="manual";
		}
	
		my @attach=map{
			"<NOBR><a href=\"$SCRIPT_NAME?ses=$PAR{ses}&act=getfile&id=$_\" TITLE=\"Download attachment\">$mess->{ATTACH}{$_}{filename}</A> (". int($mess->{ATTACH}{$_}{len}/100)/10 ."K)". 
			"&nbsp;&nbsp;&nbsp;<a href=\"$SCRIPT_NAME?ses=$PAR{ses}&act=delfile&id=$_&reckey=$PAR{reckey}&account=$PAR{account}\" >Delete</a></NOBR>"	
		} keys %{$mess->{ATTACH}};
		my $files=join("<BR>",@attach);
		my $att;
		if ($files){
		$att=<<ALL__;
          <tr> 
            <td align="right" width="11%" valign="top"><b>Attachments:</b></td>
            <td width="89%">$files</td>
          </tr>
ALL__
		}
		$page->add_regesp("{attach}",$att);
#		$page->add_regesp("{attach}",$mess->{ATTACH});

	}
	$page->SplitData("###HIDE_ALL###","###END_HIDE_ALL###");	
	$page->replaceINSIDE($REPL);
	
	$page->add_regesp('{account}',$PAR{account});
	$page->add_regesp('{personalize}',&print_personalize);
	
	$page->set_input("subject", {size=>35});
	$page->set_input("days", {size=>4});
	$page->set_input("mess", {columns=>70,rows=>30});	
	
	$page->add_regesp('{radio_autorespond}',$q->radio_group(-default=>$PAR{typesend},-name=>'typesend',-values=>['auto'],-labels=>{auto=>"Autoresponding"}));
	$page->add_regesp('{radio_manual}',$q->radio_group     (-default=>$PAR{typesend},-name=>'typesend',-values=>['manual'],-labels=>{manual=>"Manualy"}));
	$page->add_regesp('{radio_sendatdate}',$q->radio_group (-default=>$PAR{typesend},-name=>'typesend',-values=>['senddat'],-labels=>{senddat=>"At date"}));
	$page->ParseData;
	return $page->as_string;
}
sub print_show_mess{
	&printheader;
	my $mess=load_mess($PAR{mess});
	%CONF=loadCONF($PAR{account});
	$messtext=$mess->{mess};
	$unslink="$CONF{serverurl}register.cgi?em=$user->{email}&act=un&at=$PAR{account}";
	if ($mess->{typesend} ne 'unsubscribe'){
	if ($mess->{type} eq 'text'){
		if ($CONF{isaddunsubscrlink}){
			$messtext.="\n\nTo unsubscribe click on the link below:\n$unslink";
		}
	}else{
		my $link="\n\n<P>To unsubscribe click on the link below:<BR>\n<a href=\"$unslink\">$unslink</a></P>";
		if ($CONF{isaddunsubscrlink}){
			if ($messtext=~/<\/BODY>/i){
				$messtext=~s/<\/BODY>/$link <\/BODY>/i;
			}elsif($messtext=~/<\/HTML>/i){
				$messtext=~s/<\/HTML>/$link <\/HTML>/i;
			}else{
				$messtext.=$link;
			}
		}
	}
	}
	if($mess->{type}=~/html/i){
		print $messtext;
		return;
	}
	my $page = new hfparser(
		DATA =>"$SHABL_DIR/preview.html",		
	);
	$page->add_regesp('{subject}',sequre($mess->{subject}));
	$page->add_regesp('{mess}',sequre($messtext));
	$page->add_regesp('{link}',
		$q->a({-href=>get_full_url({act=>'showrfcmess'})},'Switch to RFC mode')
	);
	$page->ParseData;
	$page->print;
}

######################
sub print_getfile{
	my $sql="SELECT * from ${PREF}attach WHERE pk_attach=?";
	my $out=$db->prepare($sql);
	$out->execute($PAR{id});
	&Error;
	$output=$out->fetchrow_hashref;
	print "Content-type: application/octet-stream\nContent-Disposition: attachment; filename=$output->{filename}\n\n";
	binmode(STDOUT);
	print $output->{data};
	exit();
}
######################
sub print_delfile{
	$db->do("DELETE FROM ${PREF}attach WHERE pk_attach=?",undef,$PAR{id});
	print $q->redirect("$SCRIPT_NAME?act=mainbody&account=$PAR{account}&act2=newmess&reckey=$PAR{reckey}&ses=$PAR{ses}");
	exit(1);
}
######################
sub print_subsmess{
	my $mess=select_one_db("SELECT * FROM ${PREF}mess WHERE fk_account=? AND typesend='subscribe'",$PAR{account});
	unless ($mess->{pk_mess}){
		insert_db("${PREF}mess",{mess=>"Your message",subject=>"Subscribe message",fk_account=>$PAR{account},typesend=>'subscribe'});	
		$mess=select_one_db("SELECT * FROM ${PREF}mess WHERE fk_account=? AND typesend='subscribe'",$PAR{account});
	}
	if ($PAR{act2} eq "preview"){
		print $q->redirect("$SCRIPT_NAME?act=showmess&account=$PAR{account}&mess=$mess->{pk_mess}&ses=$PAR{ses}");
	}else{
		print $q->redirect("$SCRIPT_NAME?act=mainbody&account=$PAR{account}&act2=newmess&reckey=$mess->{pk_mess}&ses=$PAR{ses}");
	}
	exit(1);
}
#######################
sub print_unsubsmess{
	my $mess=select_one_db("SELECT * FROM ${PREF}mess WHERE fk_account=? AND typesend='unsubscribe'",$PAR{account});
	unless ($mess->{pk_mess}){
		insert_db("${PREF}mess",{mess=>"Your message",subject=>"Unsubscribe message",fk_account=>$PAR{account},typesend=>'unsubscribe'});	
		$mess=select_one_db("SELECT * FROM ${PREF}mess WHERE fk_account=? AND typesend='unsubscribe'",$PAR{account});
	}
	if ($PAR{act2} eq "preview"){
		print $q->redirect("$SCRIPT_NAME?act=showmess&account=$PAR{account}&mess=$mess->{pk_mess}&ses=$PAR{ses}");
	}else{
		print $q->redirect("$SCRIPT_NAME?act=mainbody&account=$PAR{account}&act2=newmess&reckey=$mess->{pk_mess}&ses=$PAR{ses}");
	}
	exit(1);
}
########################
sub sendtoadmin{
my $to = shift;
my $messid=shift;
my $mess=load_mess($messid);
   	$msg = new MIME::Lite 
                From    =>"$CONF{fromname} <$CONF{fromemail}> ",
                To      =>"$to",
                Subject =>$mess->{subject},
                Type    =>$TYPESEND{$mess->{type}},
                Data    =>$mess->{mess}; 
	foreach (keys %{$mess->{ATTACH}}){
		my($mime)=&mimeformat($mess->{ATTACH}{$_}{filename});
		$msg->attach
			(Type =>$mime->[0],
			Encoding =>$mime->[1],
			Filename =>$mess->{ATTACH}{$_}{filename},
			Data => $mess->{ATTACH}{$_}{data},
   		);
	}
	MIMEsendto($to,$msg);
}
sub preparetodeleteauto{
	my $messid=shift;
	my @messages = @{$db->selectcol_arrayref("select pk_mess from ${PREF}mess WHERE fk_account=$PAR{account} AND  typesend = 'auto' ORDER by days ASC")};
	&Error;
	$i=0;
	my %mess;
	foreach (@messages){
		$mess{$_}=$i;
		$i++;
	}
	my $newmess;
	if ($mess{$messid}==0){
		$newmess='NULL';
	}else{
		$newmess=$messages[$mess{$messid}-1];
	}
	$db->do("UPDATE ${PREF}user SET messlastsend=$newmess WHERE messlastsend='$messid'");
	&Error;
}
#######################
sub print_account_mess{
	my $page = new hfparser(
		DATA=>$main_shabl		
	);
	$page->add_regesp('{start_broadcast}',"");
	if ($PAR{bnsettings}){
		save_config($PAR{account},"sendsubscr",$PAR{sendsubscr});
		$CONF{sendsubscr}=$PAR{sendsubscr};
		save_config($PAR{account},"sendunsubscr",$PAR{sendunsubscr});		
		$CONF{sendunsubscr}=$PAR{sendunsubscr};
	}elsif($PAR{bnRemoveAuto}){
		my @elements=$q->param('selauto');
		foreach (@elements){
			preparetodeleteauto($_);
			$db->do("DELETE FROM ${PREF}mess WHERE pk_mess='$_'");
		}
		$db->do("DELETE FROM ${PREF}attach WHERE fk_mess IN (".join(" , ",@elements).")") if @elements;
		$db->do("DELETE FROM ${PREF}tosend WHERE fk_mess IN (".join(" , ",@elements).")") if @elements;
	}elsif($PAR{bnRemoveDate}){
		my @elements=$q->param('seldate');
		$db->do("DELETE FROM ${PREF}mess WHERE pk_mess IN (".join(" , ",@elements).")") if @elements;
		$db->do("DELETE FROM ${PREF}attach WHERE fk_mess IN (".join(" , ",@elements).")") if @elements;
		$db->do("DELETE FROM ${PREF}tosend WHERE fk_mess IN (".join(" , ",@elements).")") if @elements;
	}elsif($PAR{bnBroadkast}){
		$page->add_regesp('{start_broadcast}',"<h1 class=\"mess\">Broadcaster started in background</h1><img src=\"starter.cgi\" width=\"2\" height=\"2\"> ");
		my @elements=$q->param('seldate');
		if (@elements){
			my $sql="Select * FROM ${PREF}user WHERE fk_account = ? AND  isact=1";
			my $out=$db->prepare($sql);
			$out->execute($PAR{account});
			while (my %output=%{$out->fetchrow_hashref}){
				foreach my $mess(@elements){
					insert_db("${PREF}tosend",{fk_mess=>$mess,fk_user=>$output{pk_user}}) unless
						GetSQLCount("SELECT * FROM ${PREF}tosend WHERE fk_mess=$mess AND fk_user=$output{pk_user}");
				}
			}
			my $mess;
			foreach  $mess(@elements){
				update_db("${PREF}mess",{typesend=>'sent'},{pk_mess=>$mess});
			}
		}

	}elsif($PAR{bnClearTosent}){
		my @elements=$q->param('selsent');
		$db->do("DELETE FROM ${PREF}tosend WHERE fk_mess IN (".join(" , ",@elements).")") if @elements;
	}elsif($PAR{bnMoveNotSent}){
		my @elements=$q->param('selsent');
		my $mess;
		$db->do("DELETE FROM ${PREF}tosend WHERE fk_mess IN (".join(" , ",@elements).")") if @elements;
		foreach  $mess(@elements){
			update_db("${PREF}mess",{typesend=>'manual',senddat=>''},{pk_mess=>$mess});
		}
	}elsif($PAR{SEND}){
		$page->set_error("sendto","Incorrect email") unless (checkemail($PAR{sendto},0));	
		unless ($page->is_error()){
			my @elements=$q->param('selsent');
			@elements=(@elements,$q->param('seldate'));
			@elements=(@elements,$q->param('selauto'));		
			foreach (@elements){
				sendtoadmin($PAR{sendto},$_);
			}
		}
	}
        my $messtosend = GetSQLCount("SELECT * FROM ${PREF}mess WHERE fk_account=? and typesend<>'subscribe' AND typesend<>'subscribe'",$PAR{account});	
	unless($messtosend){
		$page->SplitData("<!--START_SENDTO-->","<!--END_SENDTO-->");
		$page->replaceINSIDE("");
	}
	$page->SplitData("#start#user_mess","#end#user_mess");
	$page->deleteBEFORE_AFTER();
	$page->set_def("sendsubscr",$CONF{sendsubscr});	
	$page->set_def("sendunsubscr",$CONF{sendunsubscr});	
	#############
	$automessages=GetSQLCount("SELECT * FROM ${PREF}mess WHERE fk_account=? and typesend='auto'",$PAR{account});
	$page->add_regesp('{autocount}',$automessages);
	if ($automessages){
		my $sql="SELECT pk_mess,subject,sent,days,sent FROM ${PREF}mess WHERE fk_account=? and typesend='auto' ORDER by days ASC";
		my $out=$db->prepare($sql);
		$out->execute($PAR{account});
		my $Auto;
		while (my %output=%{$out->fetchrow_hashref}){
			map{$output{$_}=sequre($output{$_})}keys %output;
			my $attach=load_mess_attachment($output{pk_mess});
			my @att=map{"<NOBR><a href=\"$SCRIPT_NAME?ses=$PAR{ses}&act=getfile&id=$_\">$attach->{$_}{filename}(". int(length($attach->{$_}{data})/100)/10 ."K)</A></NOBR>"} keys %$attach;
			my $att=join " ",@att;
			$Auto.=<<ALL__;
	  <tr class="data"> 
	    <td  ><INPUT type="checkbox" name="selauto" value="$output{pk_mess}"></td>
	    <td width="99%" >
	    <a href="$SCRIPT_NAME?reckey=$output{pk_mess}&ses=$PAR{ses}&act=mainbody&act2=newmess&account=$PAR{account}">$output{subject}</a>
	    </td>
	    <td  >$att</td>
	    <td  align="center">$output{sent}</td>
	    <td  align="center">$output{days}</td>
	    <td><a target="_blank" href="$SCRIPT_NAME?ses=$PAR{ses}&act=showmess&mess=$output{pk_mess}&account=$PAR{account}"
	    onClick="window.open('$SCRIPT_NAME?ses=$PAR{ses}&act=showmess&mess=$output{pk_mess}&account=$PAR{account}','','scrollbars=yes,resizable=yes,width=650,height=500'); return false;"	    
	    >Preview</a></td>	    
	  </tr>
ALL__
		}
		$page->add_regesp("<!--AUTOMESS-->",$Auto);

	}else{
		$page->SplitData("<!--START_AUTO-->","<!--END_AUTO-->");
		$page->replaceINSIDE("");
	}
	################	
	$datemessages=GetSQLCount("SELECT * FROM ${PREF}mess WHERE fk_account=? and (typesend='senddat' OR typesend='manual' OR typesend='sent')",$PAR{account});
	$page->add_regesp('{datecount}',$datemessages);
	if ($datemessages){
		my $sql="SELECT pk_mess,subject,sent,days,sent,DATE_FORMAT(senddat, '%Y-%b-%d' ) as senddat FROM ${PREF}mess WHERE fk_account=? and (typesend='senddat' OR typesend='manual' OR typesend='sent') ORDER by senddat ASC";
		my $out=$db->prepare($sql);
		$out->execute($PAR{account});
		my $Auto;
		while (my %output=%{$out->fetchrow_hashref}){
			map{$output{$_}=sequre($output{$_})}keys %output;
			my $attach=load_mess_attachment($output{pk_mess});
			my @att=map{"<NOBR><a href=\"$SCRIPT_NAME?ses=$PAR{ses}&act=getfile&id=$_\">$attach->{$_}{filename}(". int(length($attach->{$_}{data})/100)/10 ."K)</A></NOBR>"} keys %$attach;
			my $att=join " ",@att;
			
my $tosent=GetSQLCount("SELECT * FROM ${PREF}tosend WHERE fk_mess=?",$output{pk_mess});
			$Auto.=<<ALL__;
	  <tr class="data"> 
	    <td  ><INPUT type="checkbox" name="seldate" value="$output{pk_mess}"></td>
	    <td width="99%">
	    	<a href="$SCRIPT_NAME?reckey=$output{pk_mess}&ses=$PAR{ses}&act=mainbody&act2=newmess&account=$PAR{account}">$output{subject}</a>
	    </td>
	    <td  >$att</td>
	    <td  align="center">$output{senddat}</td>
	    <td  align="center">$tosent</td>
	    <td  align="center">$output{sent}</td>	    
	    <td><a target="_blank" href="$SCRIPT_NAME?ses=$PAR{ses}&act=showmess&mess=$output{pk_mess}&account=$PAR{account}"
	    onClick="window.open('$SCRIPT_NAME?ses=$PAR{ses}&act=showmess&mess=$output{pk_mess}&account=$PAR{account}','','scrollbars=yes,resizable=yes,width=650,height=500'); return false;"	    
	    >Preview</a></td>	    
	  </tr>
ALL__
		}
		$page->add_regesp("<!--DATEMESS-->",$Auto);

	}else{
		$page->SplitData("<!--START_DATE-->","<!--END_DATE-->");
		$page->replaceINSIDE("");
	}
	$page->set_def("sendto",$CONF{adminemail});	
	$page->add_regesp('{account}',$PAR{account});

	$page->ParseData;
	return $page->as_string;
}
#######################
sub print_account_page{
	my %map;
	%map=(	""       =>\&print_main_account_data,
		columns  =>\&print_columns,
		mess     =>\&print_account_mess,
		newmess  =>\&print_account_newmess,
		users    =>\&print_users,
		'bulk' =>\&print_users_bulk,
		'import' =>\&print_users_import,
		'export' =>\&print_users_export,
		'loadfrom'=>\&print_users_loadfrom,
		userform =>\&print_user_form,
		fieldform=>\&print_field_form,
		delfield =>\&delete_field,
		up       =>\&move_up_field,
		down     =>\&move_down_field,
		config   =>\&print_config		
	);
	
	$main_page=new dparser(
		DATA=>"$SHABL_DIR/main-shabl.html"
	);
	#$main_page->add_regesp('{account_name}',$q->a({href=>get_full_url({act2=>""})},$ACCOUNT{$PAR{account}}));
	$main_page->add_regesp('{account_name}',
		"<A href=$ENV{SCRIPT_NAME}?ses=$PAR{ses}&account=$PAR{account}&act=mainbody>$ACCOUNT{$PAR{account}}</A>"
	);
	$main_page->add_regesp('{account}',$PAR{account});
	$main_page->add_regesp('{main_menu}',get_account_menu(\@ACCOUNTMENU));
	my $func_ref;
	if ($map{$PAR{act2}}) {
		$func_ref=$map{$PAR{act2}};
	}else{
		$func_ref=sub{return $q->h1("Please do not experiment whith URL")}
	}
	$main_page->add_regesp('{body}',&$func_ref);
	$main_page->ParseData;
	&printheader;
	$main_page->print;	
}
####################
sub print_main{
	unless(exists($ACCOUNT{$PAR{account}})){
		&printheader;
		my $page=new dparser(
			DATA=>"$SHABL_DIR/first.html"
		);
		$page->ParseData;
		$page->print;
	}else{	
		&print_account_page;
	}

}
#########################
###accounts
sub DublicateAccountTable{
	my $table=shift;
	my $old_account=shift;
	my $new_account=shift;
	my $p_key=shift;
	my $f_key=shift;
	my $h_where=shift;
	my @where=@{$h_where};
	push @where,"$f_key=?";
	my $WHERE;
	$WHERE="WHERE ".join(" AND ",@where) if @where;
	my $sql="SELECT * FROM $table $WHERE ";
	my $out=$db->prepare($sql);
	$out->execute($old_account);
	&Error($sql);
	while (my %output=%{$out->fetchrow_hashref}){
		delete($output{$p_key});
		$output{$f_key}=$new_account;
		insert_db("$table",\%output);
	}
}
####################
sub InsertNewAccount{
	my $name=shift;
	my $target=shift;
	my $count=insert_db("${PREF}account",{name=>sequre($name),isact=>1});
	if ($PAR{target}){
		DublicateAccountTable("${PREF}conf",$PAR{target},$count,undef,"fk_account");
		DublicateAccountTable("${PREF}fields",$PAR{target},$count,"pk_fields","fk_account");
	}

	
	print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=account");
	exit(1);
}
######################
sub DeleteAccounts{
	return unless $q->param('reckey');
	my @keys=$q->param('reckey');
	my $accounts="(".join(",",@keys).")";
	
	$db->do("DELETE FROM ${PREF}account WHERE pk_account in $accounts");
	&Error("DELETE FROM ${PREF}account WHERE pk_account in $accounts");
	$db->do("DELETE FROM ${PREF}user WHERE fk_account in $accounts");	&Error("DELETE FROM ${PREF}user WHERE fk_account in $accounts");
	my $ary_ref = $db->selectcol_arrayref("select pk_mess from ${PREF}mess WHERE fk_account in $accounts");	&Error("select pk_mess from ${PREF}mess WHERE fk_account in $accounts");
	$db->do("DELETE FROM ${PREF}attach WHERE fk_mess in (".join(",",@{$ary_ref}).")") if @{$ary_ref};
	$db->do("DELETE FROM ${PREF}tosend WHERE fk_mess in $accounts");	&Error("DELETE FROM ${PREF}tosend WHERE fk_mess in $accounts");
	$db->do("DELETE FROM ${PREF}mess WHERE fk_account in $accounts");	&Error("DELETE FROM ${PREF}mess WHERE fk_account in $accounts");
	$db->do("DELETE FROM ${PREF}conf WHERE fk_account in $accounts");	&Error("DELETE FROM ${PREF}conf WHERE fk_account in $accounts");
	my $ary_ref = $db->selectcol_arrayref("select pk_fields from ${PREF}fields WHERE fk_account in $accounts");	&Error;
	$db->do("DELETE FROM ${PREF}doppar WHERE fk_fields in (".join(",",@{$ary_ref}).")") if @{$ary_ref};
	&Error("DELETE FROM ${PREF}doppar WHERE fk_fields in (".join(",",@{$ary_ref}).")");
	OPTIMIZEtables();
	print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=account");
	exit(1);
}
sub OPTIMIZEtables{	
	foreach(qw(user account mess tosend log doppar conf)){
		$db->do("OPTIMIZE TABLE ${PREF}$_");
		&Error;
	}
}
######################
sub InverseStatusAccounts{
	return unless $q->param('reckey');
	my @keys=$q->param('reckey');
	foreach my $key(@keys){
		$db->do("UPDATE  ${PREF}account SET isact=IF(isact=0,1,0) WHERE pk_account=$key");
		&Error;
	}
	print $q->redirect("$SCRIPT_NAME?ses=$PAR{ses}&act=account");
	exit(1);
}
####################
sub print_account{
	my %error;
	if ($PAR{bn_new}){
		my $count = GetSQLCount("SELECT * from ${PREF}account WHERE name=?",sequre($PAR{name}));
		if ($count){
			$error{name}="Account is already exists";
		}elsif(length($PAR{name})<3 or length($PAR{name})>8){
			$error{name}="Invalid account name";
		}else{
			&InsertNewAccount($PAR{name},$PAR{target});
		}
	}
	if ($PAR{bn_delete}){
		DeleteAccounts();
	}
	if ($PAR{bn_inverse}){
		InverseStatusAccounts();
	}	
	&printheader;
	my %input,@val,%discr;
	push (@val,0);
	$discr{0}="--blank--";
	foreach (sort {$a<=>$b} keys %ACCOUNT){
		push (@val,$_); $discr{$_}=$ACCOUNT{$_};
	}
	$input{target}={default=>"0",values=>\@val,labels=>\%discr};
	$input{name}={size=>8,maxlength=>8};
	my $page=new hfparser
	DATA=>"$SHABL_DIR/accounts.html",
	INPUT=>\%input,
	ERROR=>\%error
	;
	$page->add_regesp('{account_broser}',&show_account_broser);
	$page->set_def(name=>"new_act");
	$page->ParseData;
	$page->print;
}
####################
sub show_account_broser{
	my $out;
	my $sql="SELECT * from ${PREF}account ORDER by name asc";
	my $out1=$db->prepare($sql);
	$out1->execute();
	return "<H2>No accounts</H2>" if($out1->rows<1);
	
	$out=<<all__;
<table width="100%" border="0" cellspacing="3" cellpadding="2">
    <tr class="dataheader">
      <td width="94%" colspan="2">Your accounts:</td>
    </tr>
all__
	while (my %output=%{$out1->fetchrow_hashref}){
		my $status;
		$status=" (Disabled)" if ($output{isact}==0);
		
		$out.=<<all__;
	    <tr class="data">
		      <td width="3%"><input type="checkbox" name="reckey" value="$output{pk_account}"></td>
		      <td width="94%"><NOBR><a href="$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody&account=$output{pk_account}" target="main">$output{name}</a>$status</NOBR></td>
	    </tr>
all__
	}
	$out.=<<all__;
	<tr class="data">
	<td colspan="2" align="center">
		<input type="submit" value="Delete selected" class="buttonmy" name="bn_delete"
			onClick="if (confirm('Are you sure you want to delete selected accounts')==true){ goToURL('parent.frames[\\'main\\']', '$SCRIPT_NAME?ses=$PAR{ses}&act=mainbody') } else {return(false);}"			
		>	
	</td></tr>
	<tr class="data">
	<td colspan="2" align="center">
		<input type="submit" value="Change status" class="buttonmy" name="bn_inverse">
	</td></tr>
		
</table>
<BR><BR>
all__
	return $out;
}
####################
#end accounts
####################
sub print_frameset{
	&printheader;
	my $page=new dparser
	DATA=>"$SHABL_DIR/mainframe.html"
	;
	$page->ParseData;
	$page->print;
}
#####################
#end mapping functions
#####################
sub sessiya{
	my %error;
	if (exists($PAR{pwd})){
		if($PAR{pwd} eq $CONF{adminpwd}){
			my $sql="INSERT INTO ${PREF}ses  (ran, host,date) VALUES (?,?,$NOW)";
			my $out=$db->prepare($sql);
			my @chars=('a'..'z','A'..'Z',0..9,'_');
			my $ran=join("", @chars[map{rand @chars}(1..25)]);
			$out->execute($ran,$ENV{REMOTE_ADDR});
			&Error;
			print $q->redirect("$SCRIPT_NAME?ses=$ran");
			exit(1);
		}else{
			$error{pwd}="Incorrect password";
		}
	}
	if(exists($PAR{ses})){
		my $sql="SELECT * FROM  ${PREF}ses  WHERE (ran=?) AND (date>date_sub($NOW ,interval 25 minute))";
		my $out=$db->prepare($sql);
		$out->execute($PAR{ses});
		&Error;
		if ($out->rows > 0){
			my $id=0;
			my  %output=%{$out->fetchrow_hashref};
			$id=$output{pk_ses};
			$db->do("UPDATE ${PREF}ses SET date=$NOW WHERE pk_ses='$id'");
			&Error;
			return 1;
		}

	}

	&printheader;
	my $page=new hfparser
		DATA=>"shabl/author.html",
		ERROR=>\%error
	;
	$page->ParseData;
	$page->print;
	exit(1);

}
##############################

